ML-DSA for JOSE and COSE
Internet-Draft draft-ietf-cose-dilithium-03
Michael Prorock
mesur.io
mprorock@mesur.io
Orie Steele
Transmute
orie@transmute.industries
Rafael Misoczki
Google
rafaelmisoczki@google.com
Michael Osborne
IBM
osb@zurich.ibm.com
Christine Cloostermans
NXP
christine.cloostermans@nxp.com
02 June 2024
Security
CBOR Object Signing and Encryption
JOSE
COSE
PQC
DILITHIUM
ML-DSA
This document describes JSON Object Signing and Encryption (JOSE) and CBOR Object Signing and Encryption (COSE) serializations for Module-Lattice-Based Digital Signature Standard (ML-DSA), which was derived from Dilithium, a Post-Quantum Cryptography (PQC) based digital signature scheme.
This document does not define any new cryptography, only seralizations of existing cryptographic systems described in [FIPS-204].
Note to RFC Editor: This document should not proceed to AUTH48 until NIST completes paramater tuning and selection as a part of the PQC standardization process.
About This Document
The latest revision of this draft can be found at https://cose-wg.github.io/draft-ietf-cose-dilithium/draft-ietf-cose-dilithium.html. Status information for this document may be found at https://datatracker.ietf.org/doc/draft-ietf-cose-dilithium/.
Discussion of this document takes place on the CBOR Object Signing and Encryption Working Group mailing list (mailto:cose@ietf.org), which is archived at https://mailarchive.ietf.org/arch/browse/cose/. Subscribe at https://www.ietf.org/mailman/listinfo/cose/.
Source for this draft and an issue tracker can be found at https://github.com/cose-wg/draft-ietf-cose-dilithium.
Introduction
As noted in [FIPS-204], ML-DSA is derived from Version 3.1 of CRYSTALS-DILITHIUM, and is believed to be secure even against adversaries in possession of a large-scale quantum computer.
CRYSTALS-DILITHIUM is one of the post quantum cryptography algorithms selected in [NIST-PQC-2022].
Terminology
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
The ML-DSA Algorithm Family
The ML-DSA Signature Scheme is paramaterized to support different security levels.
This document requests the registration of the following algorithms in [IANA.jose]:
JOSE algorithms for ML-DSA
Name | alg | Description
ML-DSA-44 | ML-DSA-44 | JSON Web Signature Algorithm for ML-DSA-44
ML-DSA-65 | ML-DSA-65 | JSON Web Signature Algorithm for ML-DSA-65
ML-DSA-87 | ML-DSA-87 | JSON Web Signature Algorithm for ML-DSA-87
This document requests the registration of the following algorithms in [IANA.cose]:
COSE algorithms for ML-DSA
Name | alg | Description
ML-DSA-44 | TBD (requested assignment -48) | CBOR Object Signing Algorithm for ML-DSA-44
ML-DSA-65 | TBD (requested assignment -49) | CBOR Object Signing Algorithm for ML-DSA-65
ML-DSA-87 | TBD (requested assignment -50) | CBOR Object Signing Algorithm for ML-DSA-87
The ML-DSA Key Type
The ML-DSA Key Type is used to express Public and Private Keys for use with ML-DSA Algorithms.
This document requests the registration of the following key types in [IANA.jose]:
JSON Web Key Type for ML-DSA
Name | kty | Description
ML-DSA | ML-DSA | JSON Web Key Type for the ML-DSA Algorithm Family.
This document requests the registration of the following algorithms in [IANA.cose]:
COSE Key Type for ML-DSA
Name | kty | Description
ML-DSA | TBD (requested assignment 7) | COSE Key Type for the ML-DSA Algorithm Family.
Security Considerations
The security considerations of [RFC7515], [RFC7517] and [RFC9053] applies to this specification as well.
A detailed security analysis of ML-DSA is beyond the scope of this specification, see [FIPS-204] for additional details.
IANA Considerations
Additions to Existing Registries
New COSE Algorithms
IANA is requested to add the following entries to the COSE Algorithms Registry. The following completed registration templates are provided as described in RFC9053 and RFC9054.
ML-DSA-44
- Name: ML-DSA-44
- Value: TBD (requested assignment -48)
- Description: CBOR Object Signing Algorithm for ML-DSA-44
- Capabilities: [kty]
- Reference: RFC XXXX
- Recommended: Yes
ML-DSA-65
- Name: ML-DSA-65
- Value: TBD (requested assignment -49)
- Description: CBOR Object Signing Algorithm for ML-DSA-65
- Capabilities: [kty]
- Reference: RFC XXXX
- Recommended: Yes
ML-DSA-87
- Name: ML-DSA-87
- Value: TBD (requested assignment -50)
- Description: CBOR Object Signing Algorithm for ML-DSA-87
- Capabilities: [kty]
- Reference: RFC XXXX
- Recommended: Yes
New COSE Key Types
IANA is requested to add the following entries to the COSE Key Types Registry. The following completed registration templates are provided as described in RFC9053.
ML-DSA
- Name: ML-DSA
- Value: TBD (requested assignment 7)
- Description: COSE Key Type for the ML-DSA Algorithm Family
- Capabilities: [kty(7)]
- Reference: RFC XXXX
New COSE Key Type Parameters
IANA is requested to add the following entries to the COSE Key Type Parameters. The following completed registration templates are provided as described in RFC9053.
ML-DSA Public Key
- Key Type: TBD (requested assignment 7)
- Name: public_key
- Label: -1
- CBOR Type: bstr
- Description: Public key
- Reference: RFC XXXX
ML-DSA Secret Key
- Key Type: TBD (requested assignment 7)
- Name: secret_key
- Label: -2
- CBOR Type: bstr
- Description: Secret (or private) key.
- Reference: RFC XXXX
New JOSE Algorithms
IANA is requested to add the following entries to the JSON Web Signature and Encryption Algorithms Registry. The following completed registration templates are provided as described in RFC7518.
ML-DSA-44
- Algorithm Name: ML-DSA-44
- Algorithm Description: ML-DSA-44 as described in FIPS 204.
- Algorithm Usage Location(s): alg
- JOSE Implementation Requirements: Optional
- Change Controller: IETF
- Value registry: [IANA.jose] Algorithms
- Specification Document(s): RFC XXXX
- Algorithm Analysis Documents(s): https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.204.ipd.pdf
ML-DSA-65
- Algorithm Name: ML-DSA-65
- Algorithm Description: ML-DSA-65 as described in FIPS 204.
- Algorithm Usage Location(s): alg
- JOSE Implementation Requirements: Optional
- Change Controller: IETF
- Value registry: [IANA.jose] Algorithms
- Specification Document(s): RFC XXXX
- Algorithm Analysis Documents(s): https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.204.ipd.pdf
ML-DSA-87
- Algorithm Name: ML-DSA-87
- Algorithm Description: ML-DSA-87 as described in FIPS 204.
- Algorithm Usage Location(s): alg
- JOSE Implementation Requirements: Optional
- Change Controller: IETF
- Value registry: [IANA.jose] Algorithms
- Specification Document(s): RFC XXXX
- Algorithm Analysis Documents(s): https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.204.ipd.pdf
New JOSE Key Types
IANA is requested to add the following entries to the JSON Web Key Types Registry. The following completed registration templates are provided as described in RFC7518 RFC7638.
ML-DSA
- "kty" Parameter Value: ML-DSA
- Key Type Description: Module-Lattice-Based Digital Signature Algorithm
- JOSE Implementation Requirements: Optional
- Change Controller: IETF
- Specification Document(s): RFC XXXX
New JSON Web Key Parameters
IANA is requested to add the following entries to the JSON Web Key Parameters Registry. The following completed registration templates are provided as described in RFC7517, and RFC7638.
ML-DSA Public Key
- Parameter Name: pub
- Parameter Description: Public or verification key
- Used with "kty" Value(s): ML-DSA
- Parameter Information Class: Public
- Change Controller: IETF
- Specification Document(s): RFC XXXX
ML-DSA Secret Key
- Parameter Name: priv
- Parameter Description: Secret, private or signing key
- Used with "kty" Value(s): ML-DSA
- Parameter Information Class: Private
- Change Controller: IETF
- Specification Document(s): RFC XXXX
References
Normative References
[IANA.jose]

JSON Object Signing and Encryption (JOSE)
IANA
[IANA.cose]

CBOR Object Signing and Encryption (COSE)
IANA
[RFC7515]

JSON Web Signature (JWS)
M. Jones
J. Bradley
N. Sakimura
May 2015
RFC 7515
DOI 10.17487/RFC7515
[RFC7517]

JSON Web Key (JWK)
M. Jones
May 2015
RFC 7517
DOI 10.17487/RFC7517
[RFC9053]

CBOR Object Signing and Encryption (COSE): Initial Algorithms
J. Schaad
August 2022
RFC 9053
DOI 10.17487/RFC9053
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
Informative References
[FIPS-204]

Module-Lattice-Based Digital Signature Standard
n.d.
[NIST-PQC-2022]

Selected Algorithms 2022
n.d.
Examples
JOSE
Key Pair
Example ML-DSA-44 Private JSON Web Key

{
  "kty": "ML-DSA",
  "alg": "ML-DSA-44",
  "pub": "V53SIdVF...uvw2nuCQ",
  "priv": "V53SIdVF...cDKLbsBY"
}

Example ML-DSA-44 Public JSON Web Key

{
  "kty": "ML-DSA",
  "alg": "ML-DSA-44",
  "pub": "V53SIdVF...uvw2nuCQ"
}

Thumbprint URI
TODO
JSON Web Signature
Example ML-DSA-44 Decoded Protected Header

{
  "alg": "ML-DSA-44"
}

Example ML-DSA-44 Compact JSON Web Signature

eyJhbGciOiJ...LCJraWQiOiI0MiJ9\
.\
eyJpc3MiOiJ1cm46d...XVpZDo0NTYifQ\
.\
5MSEgQ0dZB4SeLC...AAAAAABIhMUE

COSE
Key Pair
Example ML-DSA-44 Private COSE Key

{                                   / COSE Key                /
  1: 7,                             / ML-DSA Key Type         /
  3: -48,                           / ML-DSA-44 Algorithm     /
  -1: h'7803c0f9...3f6e2c70',       / ML-DSA Private Key      /
  -2: h'7803c0f9...3bba7abd',       / ML-DSA Public Key       /
}

Example ML-DSA-44 Public COSE Key

{                                   / COSE Key                /
  1: 7,                             / ML-DSA Key Type         /
  3: -48,                           / ML-DSA-44 Algorithm     /
  -2: h'7803c0f9...3f6e2c70'        / ML-DSA Private Key      /
}

Thumbprint URI
TODO
COSE Sign 1
Example ML-DSA-44 COSE Sign 1

/ cose-sign1 / 18(
  [
    / protected / <<
      / algorithm / 1 : -49 / ML-DSA-65 /
    >>
    / unprotected / {},
    / payload / h'66616b65',
    / signature / h'53e855e8...0f263549'
  ]
)

Acknowledgments
We would like to thank Simo Sorce, Ilari Liusvaara, Neil Madden, Anders Rundgren, David Waite, and Russ Housley for their review feedback.